                 BROWSING THROUGH FILES WITH VI

This file is the "vi" Browser's Guide.  In it, we will describe
how to move backwards and forwards through a file while using
"vi".

***************************************************************
*******         Part I: Moving Around in a File         *******
***************************************************************

When reading files with "vi", you must keep track of the
position of the cursor.  The cursor is a small line or box that
indicates a particular position on the display screen.  On some
systems, the cursor blinks; on others, it does not.

Because you have just started using "vi", the cursor marks the
first nonblank character on the first line of the screen.  When
you start a "vi" session by reading in a file, the cursor always
appears at the first nonblank character of the file.

Now press the Enter key.  You will see that the cursor moves
down to the first nonblank character of the next line.  Keep
pressing Enter.  See where it puts the cursor on each line.
When you get to the bottom of the screen, keep pressing Enter.
New lines will appear one at a time.  Keep pressing Enter until
this line is the top one on the screen.  Then stop and read some
more.

Press the "-" (the minus sign) key.  You will see that the
cursor moves up to the first nonblank character of the previous
line.  In other words, entering a minus is the opposite of
pressing Enter.

Keep pressing "-" until the cursor gets to the top line of the
screen, then press it once more.  You will see the whole screen
move down to make room for an old line at the top.  Thus, Enter
and "-" let you go backward and forward through the file.  Just
those two keys will let you read everything in this file.  If
you ever find that you've read everything on the screen and have
no other instructions, just keep pressing Enter to read more of
the file.  If you want to review something that is no longer on
the screen, back up with "-".


Positioning the Cursor on the Screen:

If you just use Enter and "-" to move the cursor, you move very
slowly.  Here are three commands for moving the cursor faster:

(a)  Typing "L" (for Low) moves the cursor to the bottom line of
the screen.

(b)  Typing "H" (for High) moves the cursor to the top line of
the screen.

(c)  Typing "M" (for Middle) moves the cursor to the middle line
of the screen.

Try all of these.  It's important that you use uppercase for
"L", "H", and "M".  The case of letters is important in "vi".


Moving the Cursor Up and Down:

Now, hold down the Ctrl key and press the D key (this is called
pressing Ctrl-D, sometimes shortened to ^D).  You will see several
new lines appear at the bottom of the screen.  Ctrl-D moves Down
half a screen.

Press Ctrl-D once more, and then press Ctrl-U (hold down Ctrl and
press U).  You will see that Ctrl-D moves the cursor Down half a
screen, and Ctrl-U moves it Up.  Using Ctrl-D and Ctrl-U to move
forward and backward through a file is less work than using
Enter and "-"; you don't need to press as many keystrokes.

Ctrl-D and Ctrl-U move quickly, moving half a screen at a time.
Ctrl-F (for forward) and Ctrl-B (for backward) move almost a
full screen at a time.  Right now, press Ctrl-F, and then Ctrl-B.

Ctrl-F (probably) took you forward off this screen and Ctrl-B
brought you back.  Ctrl-F and Ctrl-B are good for moving very
quickly through files.  They aren't particularly good for going
through this "vi" file, however -- they move too far in one jump
and you'll lose what is on the screen.  But remember them for
later work.

For practice, use Ctrl-U or Ctrl-B to go back to the beginning
of the file, then use Ctrl-D or Ctrl-F to come back to this
point in the file.  You shouldn't have trouble finding this spot
again, because it comes right before the Part II heading.


***************************************************************
*******       Part II: Horizontal Cursor Movement       *******
***************************************************************

In the last section, you moved the cursor up and down.  In this
section, you'll move the cursor back and forth on the line.
Just keep pressing Enter or Ctrl-D to see new material.

The cursor is likely to be on the first nonblank character of
some line.  Press the "l" (lowercase ell).  The cursor will move
one character to the right.

Pressing "l" repeatedly keeps moving the cursor to the right,
until you get to the end of the line.  Then it stops because it
can't go any farther.

Now press "h".  You should see the cursor move to the left.  By
pressing "h" repeatedly, you can move the cursor to the left
margin.


Vertical Line Movement:

Between "h" and "l" on a standard keyboard are "j" and "k".
Pressing "j" moves the cursor down one line.  Pressing "k" moves
the cursor up one line.

"k" and "j" move up and down like "-" and Enter.  However, when
you press "j" or "k", the cursor stays in the same column on the
screen; when you press "-" or Enter, the cursor goes to the
first nonblank character of the line.  Check this out for
yourself.


Moving to the Start or End of the Line:

Moving the cursor back and forth on a line can take a long time
if you are using "h" and "l".  Try this instead.  Move the
cursor to the beginning of a line and enter the "$" character.
You will see the cursor jump to the end of the same line.

Press the "0" (zero) key, and the cursor jumps to the beginning
of the line.  Thus "$" and "0" give you a quick way to jump to
the end or the beginning of a line.


Word Movement:

Now move the cursor to the beginning of this very line, and type
"w" (lowercase).  You will see that the cursor jumps from the
"N" in "Now" to the "m" of "move".  "w" stands for "word", and
the "w" command jumps to the start of the next word...more or
less.

Keep typing "w" and you will see that the cursor usually jumps
from one word to the next, but occasionally stops at things
normally not thought of as words.  For example, it will stop at
the comma after "line".  This is because "vi" defines a "word"
as a sequence of alphabetic/numeric characters or a sequence of
nonalphabetic/numeric characters (not including blanks).  As a
result, "vi" regards punctuation characters as "words".  You'll
get used to this quickly.

Keep pressing "w", and you'll see the cursor jump from the last
word on one line to the first word of the next.  Pressing "w"
sends the cursor to the beginning of the next word, even if that
means going to the next line.

Now press "b" (lowercase).  You will see that the cursor jumps
backward to the beginning of a word.  If the cursor is already
at the beginning of a word, it will jump back to the start of
the previous word.  However, if you use the arrow keys to move
the cursor to the middle of a word, pressing "b" goes to the
start of the word that contains the cursor.  Try it.


***************************************************************
*******               Part III: Searching               *******
***************************************************************

You now know how to move the cursor up and down on the screen
and back and forth on the line.  In this part of the guide, I'll
discuss another way to move through text: searching.

When you begin looking at a file, "vi" puts the cursor at the
file's first line, but often what you want to look at is in the
middle of the file.  You can use Ctrl-D to work your way down
through the file...but this can take time.  If you know what
sort of material you are looking for, it is often faster to use
the search facility.  The search facility tells "vi" to search
through the file from the current cursor position to the next
occurrence of a particular word or phrase.


Searching Forward:

To see how it works, start by pressing Ctrl-D or Enter until
this entire paragraph is on the screen.  Move the cursor to the
beginning of this line and type a slash (/).  Be careful not to
confuse this with the backslash (\).

When you type the slash, you will see the cursor move down to
the bottom of the screen.  Now type the word "hello", then press
Enter.  You will see the cursor jump to the beginning of the
word "hello" above.  When you type a word or phrase after a
slash, "vi" searches forward for the next occurrence of that
string of characters.  The cursor is placed on the first
character of the string that is found.

Now, move the cursor to the beginning of this line and type a
slash followed by Enter.  You will see that "vi" finds this
occurrence of "hello".  If you just type a slash without
anything after it, "vi" looks for the most recent word or phrase
you searched for.


Searching Backward:

Move the cursor to this line and type a question mark (?)
followed by the word "hello", then press Enter.  You will see
that "vi" moves the cursor backward to the previous occurrence
of "hello".  When you type a word or phrase after a question
mark, "vi" searches backward for that string of characters.  As
you might guess, if you just type a question mark followed by
Enter, "vi" searches backward for the most recent thing you
searched for.  Try it.


Case Sensitivity:

When you type characters after a slash or question mark, you
should make sure you enter them in the correct case.  For
example, ask "vi" to search for "hello", but type the word in
uppercase.  You will see that "vi" prints the message "Pattern
not found" at the bottom of the screen.  As it turns out, this
file does not contain the word "hello" in uppercase, although it
has the word many times in lowercase.


Regular Expressions in "vi":

In order to make searching more useful, "vi" lets you use
regular expressions, just like the ones used by "grep".  For
example, the caret character (^) stands for the beginning of a
line.  Move the cursor to this line and type

/^line

"vi" will look for the word "line" occurring at the beginning of a
line (which is this one).

The end of a line is represented by the dollar sign ($).  Move
the cursor to this line and type

/line$

You will see that "vi" will search forward for a line
that ends in the word "line" (the previous line).

Inside patterns, the dot (.) stands for any character.  For
example, move the cursor to the beginning of this line and type

/t.e

You will see that the cursor moves to the word the.  Type "/"
over and over, and the cursor will keep jumping forward to any
sequence of three letters that starts with "t" and ends in "e".
Were you surprised that the cursor jumped into the middle of the
word "letters"?  "vi" finds character strings, even when they
are in the middle of larger words.

Whenever you enter a pattern, remember that the dot has a
special meaning.  It may look like the end of a sentence, but
don't be fooled.  For example, move the cursor to the beginning
of this paragraph and type

/end of a sentence.

The cursor moves to the string "end of a sentence," in the
previous paragraph.  The dot in the pattern matches the comma in
the actual string.  This is a mistake that beginners frequently
make.

Inside patterns, a dot followed by a star (*) stands for any
sequence of zero or more characters.  For example, move the
cursor to this line and type

/^Y.*s$

You will find the next line that begins with the letter "Y", ends
with the letter "s", and has any number of characters in between.


Wrap-Around Searches:

By default, all searches in "vi" wrap around from the bottom of
the file to the top.  For example, consider a string consisting
of two percent signs (%%).  This line is the only place in this
file where that string occurs.  Now move the cursor to this line
and search forward for the two percent signs.  The search starts
by going down to the bottom of the file.  Because "vi" won't
find the string by then, "vi" goes back to the top of the file
and keeps searching, eventually finding the string on the
preceding line.

Similarly, if you use question marks to search backward through
a file, the search will wrap around from the top of the file to
the bottom, if necessary.


***************************************************************
*******            Part IV: Moving to a Line            *******
***************************************************************

I had to save this last part until the end because it tells you
a quick way to go to the end of a file.  Just type "G"
(uppercase), and the cursor goes to the last line of the file.
If you type a number before the "G", the cursor moves to that
line in the file.  For example, "1G" goes to the first line of
the file.  Try going to the first line of the file, then coming
back here to the end.

Remember, to quit "vi" now, type ":q!" and press Enter.
